/*
 *    Blimp.h
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#ifndef _FSEL_BLIMP_DEFINED
#define _FSEL_BLIMP_DEFINED

#include "FlightPlan.h"
#include "FlightController.h"
#include "Position.h"
#include "Goal.h"
#include "MotorPower.h"
#include "Motor.h"
#include "AltitudeSensor.cpp"
#include "DirectionSensor.cpp"
#include "PositionSensor.cpp"
#include "FSELForm.h"

class Blimp {
private:
    FlightPlan plan;
    AltitudeSensor altSensor;
    DirectionSensor dirSensor;
    PositionSensor posSensor;
    Motor motor;
    char id;
    void flight();
    void getSensorInfo();
    void stop();
protected:
    FlightController *controller;
    virtual void showStatus();
    virtual void showAltitudeInfo();
    virtual void showPositionInfo();
    virtual void showDirectionInfo();
public:
    Blimp();
    virtual ~Blimp();
    PositionSensor *getPositionSensor();
    FlightPlan *getFlightPlan();
    void setCharacteristics(char *filename);
    void startAutomaticFlight();
    void testMotorSensors(MotorPower *power);
    void setFlightController(FlightController *cnt);
    unsigned long usec; 
};

#endif
