/*
 *    BlimpGUI.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
*/

#include "defs.h"
#include "Blimp.h"
#include "BlimpGUI.h"
#include "BlimpSystem.h"
#include <iostream>
using namespace std;

extern BlimpSystem blimpSystem;

BlimpGUI::BlimpGUI(int argc, char ** argv) {
    GUIInit(argc, argv);
    Blimp();
}

void BlimpGUI::showStatus()
{
    int alt = controller->getAltitudeInfo();
    Position pos = controller->getPositionInfo();
    int dir = controller->getDirectionInfo();

    GUIshowAltitudeInfo(alt);
    GUIshowPositionInfo(pos);
    GUIshowDirectionInfo(dir);

    bool playMode = blimpSystem.isAutomaticFlight();
    if (playMode) {
        controller->showStatus();
    }
}
