/*
 *    COM.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include "defs.h"

static int rffd, usfd; /* եǥץ */
static int SerialInit(char *device, int baudrate, int min, int time);
static int COMRead(int fd, char *buf, int buf_len);
static int COMWrite(int fd, char *buf, int buf_len);

void COMInit() {
    rffd = SerialInit(RFDEVICE, RFBAUDRATE, 1, 0);
    usfd = SerialInit(USDEVICE, USBAUDRATE, 1, 0);
}

void COMClose() {
//    tcsetattr(fd, TCSANOW, &oldtio);	/* 򤵤᤹ */
//    close(fd);				/* COM1ΥꥢݡȤĤ */
}

static int SerialInit(char *device, int baudrate, int min, int time) {
    int fd;
    struct termios newtio; /* ̿ݡȤ椹뤿Υ󥿡ե */

    if((fd = open(device, O_RDWR | O_NONBLOCK)) == -1) {
	/* O_RDWR:ɤ߽ξ O_NOCTTY:tty򤷤ʤ */
	perror(device);
	exit(-1);
    }

//    tcgetattr(fd, &oldtio); /* ߤΥꥢݡȤ򤵤 */
    bzero(&newtio, sizeof(newtio)); /* ݡȤι¤Τ򥯥ꥢ */

    /*
      BAUDRATE: ܡ졼Ȥ
    */
    cfsetospeed(&newtio, baudrate);
    cfsetispeed(&newtio, baudrate);
    /*
      CRTSCTS : ϤΥϡɥե
      CS8     : 8n1 (8 ӥåȡΥѥƥȥåץӥå 1)
      CLOCAL  : ³ǥʤ
      CREAD   : ʸ(receiving characters)ͭˤ롥
    */
    newtio.c_cflag = (CS8 | CLOCAL | CREAD);
    /*
      IGNPAR  : ѥƥ顼Υǡ̵뤹
      ICRNL   : CR  NL б(Ԥʤȡ¾Υԥ塼
                CR ϤƤ⡤Ϥˤʤʤ)
      ʳǤϡǥХ raw ⡼ɤǤ(¾ϽϹԤʤ)
    */
    newtio.c_iflag = 0;
    /*
      ICANON  : Υ˥Ϥͭˤ
      ƤΥ̵ˤץФƥʥ餻ʤ
    */
    newtio.c_lflag = 0;		/* 󥫥Υ˥ */

    newtio.c_oflag = 0;		/* raw⡼ */
    newtio.c_cc[VTIME] = time;	/* 饯֥ޤ̤ */
    newtio.c_cc[VMIN] = min;	/* nʸޤǥ֥å */

    tcflush(fd,TCIFLUSH);	/* ݡȤΥꥢ */
    tcsetattr(fd, TCSANOW, &newtio); /* ݡȤͭˤ */

    return fd;
}

int RFRead(char *buf, int buf_len) {
    return COMRead(rffd, buf, buf_len);
}

int USRead(char *buf, int buf_len) {
    return COMRead(usfd, buf, buf_len);
}

int RFWrite(char *buf, int buf_len) {
    return COMWrite(rffd, buf, buf_len);
}

int USWrite(char *buf, int buf_len) {
    return COMWrite(usfd, buf, buf_len);
}

static int COMRead(int fd, char *buf, int buf_len) {
    int res; /* äʸ */
    char c;
    int i = 0;
    unsigned int count = TIMEOUT_RS232C_READ;

    while (count > 0) {
	res = read(fd, &c, 1);
//	if (res == -1) {
//	    perror("readerror");
//	    exit(-1);
//	}
	if (res > 0) {
	    buf[i] = c;
	    i++;
	    if (i == buf_len || c == 0x0a) {
		return i;
	    }
	}
//	if (count % 1000 == 0)
//	    printf("%d\n",count);
	count--;
    }
    return -1;
}

static int COMWrite(int fd, char *buf, int buf_len) {
    int  flg;

    flg = write(fd ,buf, buf_len);
    if (flg == -1){
	perror("Cannot write data to serial");
	exit(-1);
    }

    return flg;
}
