/*
 *    FSELForm.h
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */


#ifndef FSELFORM_H
#define FSELFORM_H

#include <qvariant.h>
#include <qdialog.h>
#include "Position.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QLabel;
class QGroupBox;
class QLCDNumber;
class QTextBrowser;
class QTextEdit;

class FSELForm : public QDialog
{
    Q_OBJECT

public:
    FSELForm( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~FSELForm();

    QGroupBox* groupBox1;
    QLabel* textLabel2;
    QLabel* textLabel2_3;
    QLCDNumber* lCDX;
    QLCDNumber* lCDZ;
    QLCDNumber* lCDY;
    QLCDNumber* lCDY_2;
    QLabel* textLabel2_2;
    QLabel* textLabel2_2_3;
    QLabel* textLabel1;
    QGroupBox* groupBox2;
    QLabel* textLabel2_4;
    QLabel* textLabel2_2_2;
    QLabel* textLabel2_3_2;
    QLCDNumber* lCDLEFT;
    QLCDNumber* lCDRIGHT;
    QLCDNumber* lCDUP;
    QTextEdit* Status;
    QTextEdit* Goal;
    QLabel* textLabel1_2;

    void showAltitudeInfo(int);
    void showPositionInfo(Position);
    void showDirectionInfo(int);
    void showMotorPower(int up, int left, int right);
    void showStatus(char *);
    void showLandingMessage(char *);

//    void updateValue();
//    void updateText();

//public slots:
//    virtual void setValue();
//    virtual void setText();

protected:

protected slots:
    virtual void languageChange();

};

void GUIInit(int argc, char **argv);
void *GUIThread(void *param);
void GUIshowAltitudeInfo(int);
void GUIshowPositionInfo(Position);
void GUIshowDirectionInfo(int);
void GUIshowMotorPower(int up, int left, int right);
void GUIshowStatus(char *);
void GUIshowLandingMessage(char *);

#endif // FSELFORM_H
