/*
 *    FlightMode.h
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#ifndef _FSEL_FLIGHTMODE_DEFINED
#define _FSEL_FLIGHTMODE_DEFINED

#include <iostream>
#include "Characteristics.h"
#include "Position.h"
#include "MotorPower.h"

#define PI 3.14159265358979323846

class FlightMode {
protected:
    FlightMode();
    Characteristics *charact;
    map<int,int> readCharacteristics(FILE *fp);
    int getDistance(Position *pos, Position *gpos);
    int getAngle(Position *pos, int dir, Position *gpos);
    int getAltitude(int z, int gz);
public:
    virtual bool hasArrived(Position *pos, Position *gpos) = 0;
    virtual MotorPower *getMotorPower(Position *pos, int dir, Position *gpos) = 0;
};

#endif
