/*
 *    Motor.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include "defs.h"
#include "Motor.h"
#include "FSELForm.h"

void Motor::rotate(char id, MotorPower *power)
{
    char cmd[11];

    makeCommand(cmd, id, power->upper, power->left, power->right);
    sender.send(cmd);
    GUIshowMotorPower(power->upper, power->left, power->right);
}

void Motor::stop(char id)
{
    char cmd[11];

    makeCommand(cmd, id, 0, 0, 0);
    sender.send(cmd);
    GUIshowMotorPower(0, 0, 0);
}

void Motor::makeCommand(char cmd[], char id, int upper, int left, int right)
{
//    cout << upper << " " << left << " " << right << "\n";
    if (upper > 99) {
        upper = 99;
    }
    if (left > 99) {
        left = 99;
    }
    if (right > 99) {
        right = 99;
    }        
    if (upper < -99) {
        upper = -99;
    }
    if (left < -99) {
        left = -99;
    }
    if (right < -99) {
        right = -99;
    }        

    cmd[0] = id;

    cmd[1] = getSign(upper);
    cmd[2] = getChar(abs(upper) / 10);
    cmd[3] = getChar(abs(upper) % 10);

    cmd[4] = getSign(left);
    cmd[5] = getChar(abs(left) / 10);
    cmd[6] = getChar(abs(left) % 10);

    cmd[7] = getSign(right);
    cmd[8] = getChar(abs(right) / 10);
    cmd[9] = getChar(abs(right) % 10);

    cmd[10] = 0x0a;
}

char Motor::getChar(int num)
{
    return '0' + num;
}

char Motor::getSign(int num)
{
    if (num >= 0) {
        return '+';
    } else {
        return '-';
    }
}
