/*
 *    PositionData.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include "defs.h"
#include "PositionData.h"

PositionData::PositionData()
{
    data.x = INVALID_VALUE;
    data.y = INVALID_VALUE;
    data.z = INVALID_VALUE;
}

Position PositionData::read()
{
    Position newdata;    

    lock.lock();
    newdata.x = data.x;
    newdata.y = data.y;
    newdata.z = data.z;
    lock.unlock();

    return newdata;
}

void PositionData::write(Position _data)
{
    lock.lock();
    data.x = _data.x;
    data.y = _data.y;
    data.z = _data.z;
    lock.unlock();
}

void PositionData::setUSSensor(USSensor us)
{
    sensors[us.id] = us;

#ifdef DEBUG
    USSensor us0 = sensors[us.id];
    cout << "  US: " << us0.id << " ("
         << us0.pos.x << "," << us0.pos.y << "," << us0.pos.z << ")\n";
#endif
}

USSensor *PositionData::getUSSensor(int id)
{
    if (sensors.count(id) == 1) {
        return &sensors[id];
    }
    return NULL;
}
