/*
 *    RFReceiver.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include "defs.h"
#include "RFReceiver.h"

#define BUF_LEN 256

RFReceiver::RFReceiver()
{
    writer = &altitudeData;
    data = 0; //INVALID_VALUE;
}

void RFReceiver::receive()
{
    /* RF󥵤ǡ񤭽Ф */
    char buf[BUF_LEN];
    int size;
    int time;

    size = RFRead(buf, BUF_LEN);

//    if (buf[0] != TEAM_ID || size != 9)
    if (size != 9)
	return;
  
    if (buf[4] < '0' || buf[4] > '9')
	return;
    if (buf[5] < '0' || buf[5] > '9')
	return;
    if (buf[6] < '0' || buf[6] > '9')
	return;
    if (buf[7] < '0' || buf[7] > '9')
	return;

    /* 100us tanni */
    time = (buf[4] - '0') * 1000 + (buf[5] - '0') * 100 +
	(buf[6] - '0') * 10 + (buf[7] - '0');
    data = time * US_SPEED / 20; /* ƻˤƲ®Ǥ */

#ifdef DEBUG
    cout << "WRITE RF_DATA: " << data << "\n";
#endif

    writer->write(data);
}

#ifdef DEBUG
void RFReceiver::receive(int _data, unsigned long usec)
{
    data = _data;
    writer->write(data);
    cout << "WRITE RF_DATA: " << data << "\n";
    usleep(usec);
}
#endif
