/*
 *    Timer.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include "Timer.h"

static bool passed;
void alarmsignal(int signal);

Timer::Timer(){
    if (signal(SIGALRM, alarmsignal) == SIG_ERR) {
        cout << "Fail to set alarm signal";
   }
}

void Timer::start(int _period)
{
    passed = false;
    period = _period;
    alarm(_period);
}

bool Timer::passedBy()
{
    return passed;
}

void alarmsignal(int signal) {
#ifdef NOT_USE_TIMER
    passed = false;
#else
    passed = true;
#endif
    cout << "ALARM SIGNAL OCCURRED!";
}
