/*
 *    UDPReceiver.cpp
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include "defs.h"
#include "UDPReceiver.h"

#define SV_UDP_PORT 2005
#define MSGLEN 64
#define START_ANGLE 0

UDPReceiver::UDPReceiver()
{
    writer = &directionData; 
    data = 0; //INVALID_VALUE;
}

void UDPReceiver::receive()
{
    /* PCǡ񤭽Ф */
    int n, sockfd;
    socklen_t clen;
    unsigned char msg[MSGLEN];
    struct sockaddr_in cli_addr;
    struct sockaddr_in sv_addr;

    data = START_ANGLE;

    sockfd = socket(PF_INET, SOCK_DGRAM, 0);

    for (;;) {
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = PF_INET;
	sv_addr.sin_addr.s_addr = INADDR_ANY;
	sv_addr.sin_port = htons(SV_UDP_PORT);
	memset(&cli_addr, 0, sizeof(cli_addr));
	clen = sizeof(cli_addr);

	bind(sockfd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));

	while (1) {
	    n = recvfrom(sockfd, msg, MSGLEN, 0, (struct sockaddr*)&cli_addr,
			 &clen);
	    if (n < 0) {
//		printf("Error\n");
	    } else {
		if (msg[6] != 0 && msg[7] != 0) {
		    data = ((int)msg[8]) * 360 / 256;
#ifdef DEBUG
		    cout << "WRITE UDP_DATA: " << data << "\n";
#endif
		    writer->write(data);
		}
	    }
	}
    }
}

#ifdef DEBUG
void UDPReceiver::receive(int _data, unsigned long usec)
{
    data = _data;
    writer->write(data);
    cout << "WRITE UDP_DATA: " << data << "\n";
    usleep(usec);
}
#endif
