/*
 *    fsel-comm.cpp (User-input-data Received Flight Mode)
 *
 *    Copyright (c) 2005 Software Science and Technology Laboratory,
 *    Ritsumeikan University. All rights reserved.
 */

#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>

#define DEFAULT_PORT 15000

void getData(char buf[], int data);

int main(int argc, char **argv)
{
    int port;
    struct hostent *hp;
    char *remotehost;
    int sock;
    struct sockaddr_in sa;
    int alt, dir, x, y, z;
    char buf[256];

    if (argc > 1)
        remotehost = argv[1];
    else {
        fprintf(stderr, "Usage: receiver host [port]\n");
        exit(1);
    }

    if (argc > 2) {
        port = atoi(argv[2]);
    } else {
        port = DEFAULT_PORT;
    }
    if ((hp = gethostbyname(remotehost)) == NULL) {
        perror("client: hostname");
    }
    bcopy((char *)hp->h_addr, (char *)&sa.sin_addr, hp->h_length);
    sa.sin_family = hp->h_addrtype;
    sa.sin_port = port;

    if ((sock = socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0) {
        perror("client: socket");
        exit(1);
    }

    if (connect(sock, (struct sockaddr *)&sa, sizeof(sa)) < 0) {
        perror("client: connect");
        exit(1);
    }

    alt = 0;
    while (alt >= 0) {
    fprintf(stdout, "Input sensor data (alt, x, y, z, dir): ");
        fscanf(stdin, "%d %d %d %d %d", &alt, &x, &y, &z, &dir);
        getData(buf, alt);
        write(sock, buf, strlen(buf));

        getData(buf, x);
        write(sock, buf, strlen(buf));

        getData(buf, y);
        write(sock, buf, strlen(buf));

        getData(buf, z);
        write(sock, buf, strlen(buf));

        getData(buf, dir);
        write(sock, buf, strlen(buf));
	usleep(500000);
        fprintf(stdout, "  %d %d %d %d %d\n", alt, x, y, z, dir);
    }

    close(sock);
}

void getData(char buf[], int data)
{
    if (data >= 0) {
        buf[0] = '+';
    } else {
        buf[0] = '-';
    }
    data = abs(data);
    sprintf(buf + 1, "%05d", data);
//    buf[1] = data / 100 + '0';
//    buf[2] = (data % 100) / 10 + '0';
//    buf[3] = (data % 100) % 10 + '0';
//    buf[4] = '\0';

    
}
